package org.jeecg.modules.stm.wb.config.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;


import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.wb.config.entity.WbCheckItem;
import org.jeecg.modules.stm.wb.config.service.IWbCheckItemService;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.List;

 /**
 * @Description: 节点项
 * @Author: jeecg-boot
 * @Date:   2025-06-13
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/wb.config/wbCheckItem")
@Slf4j
public class WbCheckItemController extends JeecgController<WbCheckItem, IWbCheckItemService> {
	@Autowired
	private IWbCheckItemService wbCheckItemService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbCheckItem
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "节点项-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<WbCheckItem>> queryPageList(WbCheckItem wbCheckItem,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbCheckItem> queryWrapper = QueryGenerator.initQueryWrapper(wbCheckItem, req.getParameterMap());
		Page<WbCheckItem> page = new Page<WbCheckItem>(pageNo, pageSize);
		IPage<WbCheckItem> pageList = wbCheckItemService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @GetMapping(value = "/alllist")
	 public Result<List<WbCheckItem>> queryAllList(WbCheckItem wbCheckItem, HttpServletRequest req) {
		if(wbCheckItem.getTp()==1){
			List<WbCheckItem> list = wbCheckItemService.queryWbCheckItems(wbCheckItem.getCheckId());
			return Result.OK(list);
		} else {
			List<WbCheckItem> list = wbCheckItemService.queryWbCheckMtrics(wbCheckItem.getCheckId());
			return Result.OK(list);
		}
	 }
	
	/**
	 *   添加
	 *
	 * @param wbCheckItem
	 * @return
	 */
	@AutoLog(value = "节点项-添加")
	  
	@RequiresPermissions("wb.config:wb_check_item:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbCheckItem wbCheckItem) {
		wbCheckItemService.save(wbCheckItem);
		return Result.OK("添加成功！");
	}

	 @PostMapping(value = "/saveBatch")
	 public Result<String> saveBatch(@RequestBody List<WbCheckItem> list) {
		 if(list.size()>0)  {
			 Integer[] ids = list.stream().map(WbCheckItem::getTid).toArray(Integer[]::new);
			 Integer checkId = list.get(0).getCheckId();
			 Integer tp = list.get(0).getTp();
			 QueryWrapper<WbCheckItem> queryWrapper = new QueryWrapper<>();
			 queryWrapper.in("tid",ids).eq("tp",tp).eq("check_id",checkId);
			 wbCheckItemService.remove(queryWrapper);
			 wbCheckItemService.saveBatch(list);
		 }
		 return Result.OK("添加成功！");
	 }
	
	/**
	 *  编辑
	 *
	 * @param wbCheckItem
	 * @return
	 */
	@AutoLog(value = "节点项-编辑")
	  
	@RequiresPermissions("wb.config:wb_check_item:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbCheckItem wbCheckItem) {
		wbCheckItemService.updateById(wbCheckItem);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "节点项-通过id删除")
	  
	@RequiresPermissions("wb.config:wb_check_item:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbCheckItemService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "节点项-批量删除")
	  
	@RequiresPermissions("wb.config:wb_check_item:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbCheckItemService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "节点项-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<WbCheckItem> queryById(@RequestParam(name="id",required=true) String id) {
		WbCheckItem wbCheckItem = wbCheckItemService.getById(id);
		if(wbCheckItem==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbCheckItem);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbCheckItem
    */
    @RequiresPermissions("wb.config:wb_check_item:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbCheckItem wbCheckItem) {
        return super.exportXls(request, wbCheckItem, WbCheckItem.class, "节点项");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.config:wb_check_item:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbCheckItem.class);
    }

}
